Ext.namespace('dSS11', 'dSS11.sys');

dSS11.sys.SSHForm = Ext.extend(Ext.form.FormPanel,
{
    initComponent: function()
    {
        Ext.apply(this, {
            height: 29,
            layout: 'absolute',
            items:
            [

                {
                    xtype: 'label',
                    text: _("Enable access via SSH") + ':',
                    x: 0,
                    y: 8
                },
                {
                    xtype: 'checkbox',
                    name: 'ssh',
                    ref: 'enableSSH',
                    checked: false,
                    x: 247,
                    y: 3
                },
                {
                    xtype: 'button',
                    text: _("Apply"),
                    minWidth: 90,
                    handler: this.setSSH.createDelegate(this),
                    x: 275,
                    y: 5
                }
            ]
        });

        dSS11.sys.SSHForm.superclass.initComponent.apply(this, arguments);
    },
    setSSH:  function() {
        var maskEl = this.findParentByType('fieldset').ownerCt.el;

        maskEl.mask(_("Applying changes") + '...', 'x-mask-loading');

        this.getForm().submit({
            url: '/cgi-bin/sshconfwrapper.sh',
            method: 'GET',
            scope: this,
            success: function(form, action) {
                maskEl.unmask();
                dSS11.StatusBar.setMessage(_("SSH settings applied " +
                                             "successfully"));
            },
            failure: function(form, action) {
                maskEl.unmask();
                if (action.failureType === Ext.form.Action.CONNECT_FAILURE) {
                    Ext.Msg.alert(_("Error"),
                            _("Could not configure SSH settings, AJAX " +
                              "communication failed"));
                    return;
                }

                try {
                    var jsonData = Ext.util.JSON.decode(
                                                action.response.responseText);
                    Ext.Msg.alert(_("Error"), jsonData.message);
                } catch (error) {
                    Ext.Msg.alert(_("Error"), _("Could not configure SSH " +
                                  "settings") + ": " + error.message);
                }
            }
        });
    },
    reloadSSH: function() {
        var maskEl = this.findParentByType('fieldset').ownerCt.el;
        maskEl.mask(_("Loading SSH settings") + "...", 'x-mask-loading');
        this.load(
        {
            url: '/cgi-bin/sshinfo.sh',
            method: "GET",
            scope: this,
            disableCaching: true,
            success: function(form, action) {
                maskEl.unmask();
                try {
                    var jsonData = Ext.util.JSON.decode(
                                            action.response.responseText);

                    if (jsonData.success !== true) {
                        Ext.Msg.alert(_("Error"), jsonData.message);
                        return;
                    }
                } catch (error) {
                    Ext.Msg.alert(_("Error"),
                                  _("Could not load SSH settings") +
                                    ": "  + error.message);
                }
            },
            failure: function(form, action) {
                maskEl.unmask();
                if (action.failureType === Ext.form.Action.CONNECT_FAILURE) {
                    Ext.Msg.alert(_("Error"),
                            _("Could not load SSH settings, AJAX " +
                              "communication failed"));
                    return;
                }

                try {
                    var jsonData = Ext.util.JSON.decode(
                                                action.response.responseText);
                    Ext.Msg.alert(_("Error"), jsonData.message);
                } catch (error) {
                    Ext.Msg.alert(_("Error"), _("Could not load SSH " +
                                  "settings") + ": " + error.message);
                }
            }
        });
    }
});

Ext.reg('dss11sshform', dSS11.sys.SSHForm);
